/*******************************************************************************
 * Copyright (c) 2014 Bosch Software Innovations GmbH and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v1.0 which accompany this distribution.
 *
 * The Eclipse Public License is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * The Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 * Bosch Software Innovations GmbH - Please refer to git log
 *
 *******************************************************************************/
/*
 * generated by Xtext
 */
grammar InternalInformationModel;

options {
	superClass=AbstractInternalContentAssistParser;
}

@lexer::header {
package org.eclipse.vorto.editor.infomodel.ide.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer;
}

@parser::header {
package org.eclipse.vorto.editor.infomodel.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.vorto.editor.infomodel.services.InformationModelGrammarAccess;

}
@parser::members {
	private InformationModelGrammarAccess grammarAccess;

	public void setGrammarAccess(InformationModelGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}

	@Override
	protected Grammar getGrammar() {
		return grammarAccess.getGrammar();
	}

	@Override
	protected String getValueForTokenName(String tokenName) {
		return tokenName;
	}
}

// Entry rule entryRuleInformationModel
entryRuleInformationModel
:
{ before(grammarAccess.getInformationModelRule()); }
	 ruleInformationModel
{ after(grammarAccess.getInformationModelRule()); } 
	 EOF 
;

// Rule InformationModel
ruleInformationModel 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getInformationModelAccess().getGroup()); }
		(rule__InformationModel__Group__0)
		{ after(grammarAccess.getInformationModelAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleCATEGORY
entryRuleCATEGORY
:
{ before(grammarAccess.getCATEGORYRule()); }
	 ruleCATEGORY
{ after(grammarAccess.getCATEGORYRule()); } 
	 EOF 
;

// Rule CATEGORY
ruleCATEGORY 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getCATEGORYAccess().getGroup()); }
		(rule__CATEGORY__Group__0)
		{ after(grammarAccess.getCATEGORYAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleQualifiedName
entryRuleQualifiedName
:
{ before(grammarAccess.getQualifiedNameRule()); }
	 ruleQualifiedName
{ after(grammarAccess.getQualifiedNameRule()); } 
	 EOF 
;

// Rule QualifiedName
ruleQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getQualifiedNameAccess().getGroup()); }
		(rule__QualifiedName__Group__0)
		{ after(grammarAccess.getQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleFunctionblockProperty
entryRuleFunctionblockProperty
:
{ before(grammarAccess.getFunctionblockPropertyRule()); }
	 ruleFunctionblockProperty
{ after(grammarAccess.getFunctionblockPropertyRule()); } 
	 EOF 
;

// Rule FunctionblockProperty
ruleFunctionblockProperty 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getFunctionblockPropertyAccess().getGroup()); }
		(rule__FunctionblockProperty__Group__0)
		{ after(grammarAccess.getFunctionblockPropertyAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleModelReference
entryRuleModelReference
:
{ before(grammarAccess.getModelReferenceRule()); }
	 ruleModelReference
{ after(grammarAccess.getModelReferenceRule()); } 
	 EOF 
;

// Rule ModelReference
ruleModelReference 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getModelReferenceAccess().getGroup()); }
		(rule__ModelReference__Group__0)
		{ after(grammarAccess.getModelReferenceAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__0__Impl
	rule__InformationModel__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getInformationModelAction_0()); }
	()
	{ after(grammarAccess.getInformationModelAccess().getInformationModelAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__1__Impl
	rule__InformationModel__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getNamespaceKeyword_1()); }
	'namespace'
	{ after(grammarAccess.getInformationModelAccess().getNamespaceKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__2__Impl
	rule__InformationModel__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getNamespaceAssignment_2()); }
	(rule__InformationModel__NamespaceAssignment_2)
	{ after(grammarAccess.getInformationModelAccess().getNamespaceAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__3__Impl
	rule__InformationModel__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getVersionKeyword_3()); }
	'version'
	{ after(grammarAccess.getInformationModelAccess().getVersionKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__4__Impl
	rule__InformationModel__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getVersionAssignment_4()); }
	(rule__InformationModel__VersionAssignment_4)
	{ after(grammarAccess.getInformationModelAccess().getVersionAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__5__Impl
	rule__InformationModel__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getDisplaynameKeyword_5()); }
	'displayname'
	{ after(grammarAccess.getInformationModelAccess().getDisplaynameKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__6__Impl
	rule__InformationModel__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getDisplaynameAssignment_6()); }
	(rule__InformationModel__DisplaynameAssignment_6)
	{ after(grammarAccess.getInformationModelAccess().getDisplaynameAssignment_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__7__Impl
	rule__InformationModel__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getGroup_7()); }
	(rule__InformationModel__Group_7__0)?
	{ after(grammarAccess.getInformationModelAccess().getGroup_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__8__Impl
	rule__InformationModel__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getCategoryKeyword_8()); }
	'category'
	{ after(grammarAccess.getInformationModelAccess().getCategoryKeyword_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__9__Impl
	rule__InformationModel__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getCategoryAssignment_9()); }
	(rule__InformationModel__CategoryAssignment_9)
	{ after(grammarAccess.getInformationModelAccess().getCategoryAssignment_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__10__Impl
	rule__InformationModel__Group__11
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getReferencesAssignment_10()); }
	(rule__InformationModel__ReferencesAssignment_10)*
	{ after(grammarAccess.getInformationModelAccess().getReferencesAssignment_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__11
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__11__Impl
	rule__InformationModel__Group__12
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__11__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getInfomodelKeyword_11()); }
	'infomodel'
	{ after(grammarAccess.getInformationModelAccess().getInfomodelKeyword_11()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__12
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__12__Impl
	rule__InformationModel__Group__13
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__12__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getNameAssignment_12()); }
	(rule__InformationModel__NameAssignment_12)
	{ after(grammarAccess.getInformationModelAccess().getNameAssignment_12()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__13
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__13__Impl
	rule__InformationModel__Group__14
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__13__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getLeftCurlyBracketKeyword_13()); }
	'{'
	{ after(grammarAccess.getInformationModelAccess().getLeftCurlyBracketKeyword_13()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__14
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__14__Impl
	rule__InformationModel__Group__15
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__14__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getGroup_14()); }
	(rule__InformationModel__Group_14__0)?
	{ after(grammarAccess.getInformationModelAccess().getGroup_14()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__15
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group__15__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group__15__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getRightCurlyBracketKeyword_15()); }
	'}'
	{ after(grammarAccess.getInformationModelAccess().getRightCurlyBracketKeyword_15()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InformationModel__Group_7__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group_7__0__Impl
	rule__InformationModel__Group_7__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_7__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getDescriptionKeyword_7_0()); }
	'description'
	{ after(grammarAccess.getInformationModelAccess().getDescriptionKeyword_7_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_7__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group_7__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_7__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getDescriptionAssignment_7_1()); }
	(rule__InformationModel__DescriptionAssignment_7_1)
	{ after(grammarAccess.getInformationModelAccess().getDescriptionAssignment_7_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InformationModel__Group_14__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group_14__0__Impl
	rule__InformationModel__Group_14__1
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getFunctionblocksKeyword_14_0()); }
	'functionblocks'
	{ after(grammarAccess.getInformationModelAccess().getFunctionblocksKeyword_14_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group_14__1__Impl
	rule__InformationModel__Group_14__2
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getLeftCurlyBracketKeyword_14_1()); }
	'{'
	{ after(grammarAccess.getInformationModelAccess().getLeftCurlyBracketKeyword_14_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group_14__2__Impl
	rule__InformationModel__Group_14__3
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getPropertiesAssignment_14_2()); }
	(rule__InformationModel__PropertiesAssignment_14_2)*
	{ after(grammarAccess.getInformationModelAccess().getPropertiesAssignment_14_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__InformationModel__Group_14__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__Group_14__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getInformationModelAccess().getRightCurlyBracketKeyword_14_3()); }
	'}'
	{ after(grammarAccess.getInformationModelAccess().getRightCurlyBracketKeyword_14_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__CATEGORY__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group__0__Impl
	rule__CATEGORY__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getGroup_1()); }
	(rule__CATEGORY__Group_1__0)*
	{ after(grammarAccess.getCATEGORYAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__CATEGORY__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group_1__0__Impl
	rule__CATEGORY__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0()); }
	'/'
	{ after(grammarAccess.getCATEGORYAccess().getSolidusKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__CATEGORY__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__CATEGORY__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1()); }
	RULE_ID
	{ after(grammarAccess.getCATEGORYAccess().getIDTerminalRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__QualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group__0__Impl
	rule__QualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); }
	RULE_ID
	{ after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getGroup_1()); }
	(rule__QualifiedName__Group_1__0)*
	{ after(grammarAccess.getQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__QualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group_1__0__Impl
	rule__QualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__QualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__QualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); }
	RULE_ID
	{ after(grammarAccess.getQualifiedNameAccess().getIDTerminalRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__FunctionblockProperty__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionblockProperty__Group__0__Impl
	rule__FunctionblockProperty__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionblockPropertyAccess().getNameAssignment_0()); }
	(rule__FunctionblockProperty__NameAssignment_0)
	{ after(grammarAccess.getFunctionblockPropertyAccess().getNameAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionblockProperty__Group__1__Impl
	rule__FunctionblockProperty__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionblockPropertyAccess().getAsKeyword_1()); }
	'as'
	{ after(grammarAccess.getFunctionblockPropertyAccess().getAsKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionblockProperty__Group__2__Impl
	rule__FunctionblockProperty__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionblockPropertyAccess().getTypeAssignment_2()); }
	(rule__FunctionblockProperty__TypeAssignment_2)
	{ after(grammarAccess.getFunctionblockPropertyAccess().getTypeAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__FunctionblockProperty__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getFunctionblockPropertyAccess().getDescriptionAssignment_3()); }
	(rule__FunctionblockProperty__DescriptionAssignment_3)?
	{ after(grammarAccess.getFunctionblockPropertyAccess().getDescriptionAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ModelReference__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__0__Impl
	rule__ModelReference__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getUsingKeyword_0()); }
	'using'
	{ after(grammarAccess.getModelReferenceAccess().getUsingKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__1__Impl
	rule__ModelReference__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getImportedNamespaceAssignment_1()); }
	(rule__ModelReference__ImportedNamespaceAssignment_1)
	{ after(grammarAccess.getModelReferenceAccess().getImportedNamespaceAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__2__Impl
	rule__ModelReference__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2()); }
	';'
	{ after(grammarAccess.getModelReferenceAccess().getSemicolonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ModelReference__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getModelReferenceAccess().getVersionAssignment_3()); }
	(rule__ModelReference__VersionAssignment_3)
	{ after(grammarAccess.getModelReferenceAccess().getVersionAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__InformationModel__NamespaceAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getNamespaceQualifiedNameParserRuleCall_2_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getInformationModelAccess().getNamespaceQualifiedNameParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__VersionAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getVersionVERSIONTerminalRuleCall_4_0()); }
		RULE_VERSION
		{ after(grammarAccess.getInformationModelAccess().getVersionVERSIONTerminalRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__DisplaynameAssignment_6
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getDisplaynameSTRINGTerminalRuleCall_6_0()); }
		RULE_STRING
		{ after(grammarAccess.getInformationModelAccess().getDisplaynameSTRINGTerminalRuleCall_6_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__DescriptionAssignment_7_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getInformationModelAccess().getDescriptionSTRINGTerminalRuleCall_7_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__CategoryAssignment_9
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getCategoryCATEGORYParserRuleCall_9_0()); }
		ruleCATEGORY
		{ after(grammarAccess.getInformationModelAccess().getCategoryCATEGORYParserRuleCall_9_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__ReferencesAssignment_10
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getReferencesModelReferenceParserRuleCall_10_0()); }
		ruleModelReference
		{ after(grammarAccess.getInformationModelAccess().getReferencesModelReferenceParserRuleCall_10_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__NameAssignment_12
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getNameIDTerminalRuleCall_12_0()); }
		RULE_ID
		{ after(grammarAccess.getInformationModelAccess().getNameIDTerminalRuleCall_12_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__InformationModel__PropertiesAssignment_14_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getInformationModelAccess().getPropertiesFunctionblockPropertyParserRuleCall_14_2_0()); }
		ruleFunctionblockProperty
		{ after(grammarAccess.getInformationModelAccess().getPropertiesFunctionblockPropertyParserRuleCall_14_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__NameAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionblockPropertyAccess().getNameIDTerminalRuleCall_0_0()); }
		RULE_ID
		{ after(grammarAccess.getFunctionblockPropertyAccess().getNameIDTerminalRuleCall_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__TypeAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionblockPropertyAccess().getTypeFunctionblockModelCrossReference_2_0()); }
		(
			{ before(grammarAccess.getFunctionblockPropertyAccess().getTypeFunctionblockModelQualifiedNameParserRuleCall_2_0_1()); }
			ruleQualifiedName
			{ after(grammarAccess.getFunctionblockPropertyAccess().getTypeFunctionblockModelQualifiedNameParserRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getFunctionblockPropertyAccess().getTypeFunctionblockModelCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__FunctionblockProperty__DescriptionAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getFunctionblockPropertyAccess().getDescriptionSTRINGTerminalRuleCall_3_0()); }
		RULE_STRING
		{ after(grammarAccess.getFunctionblockPropertyAccess().getDescriptionSTRINGTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__ImportedNamespaceAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0()); }
		ruleQualifiedName
		{ after(grammarAccess.getModelReferenceAccess().getImportedNamespaceQualifiedNameParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ModelReference__VersionAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
		RULE_VERSION
		{ after(grammarAccess.getModelReferenceAccess().getVersionVERSIONTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

RULE_VERSION : ('0'..'9')* '.' ('0'..'9')* '.' ('0'..'9')* ('-' RULE_ID)?;

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
